diff --git a/src/backend/catalog/pg_depend.c b/src/backend/catalog/pg_depend.c
index e86e5e6898..20ebdcc6e6 100644
--- a/src/backend/catalog/pg_depend.c
+++ b/src/backend/catalog/pg_depend.c
@@ -266,7 +266,7 @@ deleteDependencyRecordsFor(Oid classId, Oid objectId,
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
 		if (skipExtensionDeps &&
-			((Form_pg_depend) GETSTRUCT(tup))->deptype == DEPENDENCY_EXTENSION)
+			(GETSTRUCT(pg_depend, tup))->deptype == DEPENDENCY_EXTENSION)
 			continue;
 
 		CatalogTupleDelete(depRel, &tup->t_self);
@@ -315,7 +315,7 @@ deleteDependencyRecordsForClass(Oid classId, Oid objectId,
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend depform = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend depform = GETSTRUCT(pg_depend, tup);
 
 		if (depform->refclassid == refclassId && depform->deptype == deptype)
 		{
@@ -362,7 +362,7 @@ deleteDependencyRecordsForSpecific(Oid classId, Oid objectId, char deptype,
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend depform = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend depform = GETSTRUCT(pg_depend, tup);
 
 		if (depform->refclassid == refclassId &&
 			depform->refobjid == refobjectId &&
@@ -464,7 +464,7 @@ changeDependencyFor(Oid classId, Oid objectId,
 
 	while (HeapTupleIsValid((tup = systable_getnext(scan))))
 	{
-		Form_pg_depend depform = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend depform = GETSTRUCT(pg_depend, tup);
 
 		if (depform->refclassid == refClassId &&
 			depform->refobjid == oldRefObjectId)
@@ -475,7 +475,7 @@ changeDependencyFor(Oid classId, Oid objectId,
 			{
 				/* make a modifiable copy */
 				tup = heap_copytuple(tup);
-				depform = (Form_pg_depend) GETSTRUCT(tup);
+				depform = GETSTRUCT(pg_depend, tup);
 
 				depform->refobjid = newRefObjectId;
 
@@ -533,7 +533,7 @@ changeDependenciesOf(Oid classId, Oid oldObjectId,
 
 		/* make a modifiable copy */
 		tup = heap_copytuple(tup);
-		depform = (Form_pg_depend) GETSTRUCT(tup);
+		depform = GETSTRUCT(pg_depend, tup);
 
 		depform->objid = newObjectId;
 
@@ -620,7 +620,7 @@ changeDependenciesOn(Oid refClassId, Oid oldRefObjectId,
 
 			/* make a modifiable copy */
 			tup = heap_copytuple(tup);
-			depform = (Form_pg_depend) GETSTRUCT(tup);
+			depform = GETSTRUCT(pg_depend, tup);
 
 			depform->refobjid = newRefObjectId;
 
@@ -695,7 +695,7 @@ getExtensionOfObject(Oid classId, Oid objectId)
 
 	while (HeapTupleIsValid((tup = systable_getnext(scan))))
 	{
-		Form_pg_depend depform = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend depform = GETSTRUCT(pg_depend, tup);
 
 		if (depform->refclassid == ExtensionRelationId &&
 			depform->deptype == DEPENDENCY_EXTENSION)
@@ -741,7 +741,7 @@ getAutoExtensionsOfObject(Oid classId, Oid objectId)
 
 	while (HeapTupleIsValid((tup = systable_getnext(scan))))
 	{
-		Form_pg_depend depform = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend depform = GETSTRUCT(pg_depend, tup);
 
 		if (depform->refclassid == ExtensionRelationId &&
 			depform->deptype == DEPENDENCY_AUTO_EXTENSION)
@@ -791,7 +791,7 @@ sequenceIsOwned(Oid seqId, char deptype, Oid *tableId, int32 *colId)
 
 	while (HeapTupleIsValid((tup = systable_getnext(scan))))
 	{
-		Form_pg_depend depform = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend depform = GETSTRUCT(pg_depend, tup);
 
 		if (depform->refclassid == RelationRelationId &&
 			depform->deptype == deptype)
@@ -845,7 +845,7 @@ getOwnedSequences_internal(Oid relid, AttrNumber attnum, char deptype)
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend deprec = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend deprec = GETSTRUCT(pg_depend, tup);
 
 		/*
 		 * We assume any auto or internal dependency of a sequence on a column
@@ -937,7 +937,7 @@ get_index_constraint(Oid indexId)
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend deprec = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend deprec = GETSTRUCT(pg_depend, tup);
 
 		/*
 		 * We assume any internal dependency on a constraint must be what we
@@ -993,7 +993,7 @@ get_index_ref_constraints(Oid indexId)
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend deprec = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend deprec = GETSTRUCT(pg_depend, tup);
 
 		/*
 		 * We assume any normal dependency from a constraint must be what we
diff --git a/src/backend/catalog/pg_enum.c b/src/backend/catalog/pg_enum.c
index 114715498d..3a518b9122 100644
--- a/src/backend/catalog/pg_enum.c
+++ b/src/backend/catalog/pg_enum.c
@@ -292,7 +292,7 @@ restart:
 		 */
 		if (nelems > 0)
 		{
-			Form_pg_enum en = (Form_pg_enum) GETSTRUCT(existing[nelems - 1]);
+			Form_pg_enum en = GETSTRUCT(pg_enum, existing[nelems - 1]);
 
 			newelemorder = en->enumsortorder + 1;
 		}
@@ -310,7 +310,7 @@ restart:
 		/* Locate the neighbor element */
 		for (nbr_index = 0; nbr_index < nelems; nbr_index++)
 		{
-			Form_pg_enum en = (Form_pg_enum) GETSTRUCT(existing[nbr_index]);
+			Form_pg_enum en = GETSTRUCT(pg_enum, existing[nbr_index]);
 
 			if (strcmp(NameStr(en->enumlabel), neighbor) == 0)
 				break;
@@ -320,7 +320,7 @@ restart:
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 					 errmsg("\"%s\" is not an existing enum label",
 							neighbor)));
-		nbr_en = (Form_pg_enum) GETSTRUCT(existing[nbr_index]);
+		nbr_en = GETSTRUCT(pg_enum, existing[nbr_index]);
 
 		/*
 		 * Attempt to assign an appropriate enumsortorder value: one less than
@@ -352,7 +352,7 @@ restart:
 			 */
 			volatile float4 midpoint;
 
-			other_nbr_en = (Form_pg_enum) GETSTRUCT(existing[other_nbr_index]);
+			other_nbr_en = GETSTRUCT(pg_enum, existing[other_nbr_index]);
 			midpoint = (nbr_en->enumsortorder +
 						other_nbr_en->enumsortorder) / 2;
 
@@ -418,7 +418,7 @@ restart:
 			for (i = 0; i < nelems; i++)
 			{
 				HeapTuple	exists_tup = existing[i];
-				Form_pg_enum exists_en = (Form_pg_enum) GETSTRUCT(exists_tup);
+				Form_pg_enum exists_en = GETSTRUCT(pg_enum, exists_tup);
 				Oid			exists_oid = exists_en->oid;
 
 				if (exists_oid & 1)
@@ -552,7 +552,7 @@ RenameEnumLabel(Oid enumTypeOid,
 	for (i = 0; i < nelems; i++)
 	{
 		enum_tup = &(list->members[i]->tuple);
-		en = (Form_pg_enum) GETSTRUCT(enum_tup);
+		en = GETSTRUCT(pg_enum, enum_tup);
 		if (strcmp(NameStr(en->enumlabel), oldVal) == 0)
 			old_tup = enum_tup;
 		if (strcmp(NameStr(en->enumlabel), newVal) == 0)
@@ -571,7 +571,7 @@ RenameEnumLabel(Oid enumTypeOid,
 
 	/* OK, make a writable copy of old tuple */
 	enum_tup = heap_copytuple(old_tup);
-	en = (Form_pg_enum) GETSTRUCT(enum_tup);
+	en = GETSTRUCT(pg_enum, enum_tup);
 
 	ReleaseCatCacheList(list);
 
@@ -656,7 +656,7 @@ RenumberEnumType(Relation pg_enum, HeapTuple *existing, int nelems)
 		float4		newsortorder;
 
 		newtup = heap_copytuple(existing[i]);
-		en = (Form_pg_enum) GETSTRUCT(newtup);
+		en = GETSTRUCT(pg_enum, newtup);
 
 		newsortorder = i + 1;
 		if (en->enumsortorder != newsortorder)
@@ -680,8 +680,8 @@ sort_order_cmp(const void *p1, const void *p2)
 {
 	HeapTuple	v1 = *((const HeapTuple *) p1);
 	HeapTuple	v2 = *((const HeapTuple *) p2);
-	Form_pg_enum en1 = (Form_pg_enum) GETSTRUCT(v1);
-	Form_pg_enum en2 = (Form_pg_enum) GETSTRUCT(v2);
+	Form_pg_enum en1 = GETSTRUCT(pg_enum, v1);
+	Form_pg_enum en2 = GETSTRUCT(pg_enum, v2);
 
 	if (en1->enumsortorder < en2->enumsortorder)
 		return -1;
diff --git a/src/backend/catalog/pg_inherits.c b/src/backend/catalog/pg_inherits.c
index 92afbc2f25..2764c1c35c 100644
--- a/src/backend/catalog/pg_inherits.c
+++ b/src/backend/catalog/pg_inherits.c
@@ -136,7 +136,7 @@ find_inheritance_children_extended(Oid parentrelId, bool omit_detached,
 		 * SERIALIZABLE transactions: such queries use a different snapshot
 		 * than the one used by regular (user) queries.
 		 */
-		if (((Form_pg_inherits) GETSTRUCT(inheritsTuple))->inhdetachpending)
+		if ((GETSTRUCT(pg_inherits, inheritsTuple))->inhdetachpending)
 		{
 			if (detached_exist)
 				*detached_exist = true;
@@ -179,7 +179,7 @@ find_inheritance_children_extended(Oid parentrelId, bool omit_detached,
 			}
 		}
 
-		inhrelid = ((Form_pg_inherits) GETSTRUCT(inheritsTuple))->inhrelid;
+		inhrelid = (GETSTRUCT(pg_inherits, inheritsTuple))->inhrelid;
 		if (numoids >= maxoids)
 		{
 			maxoids *= 2;
@@ -362,7 +362,7 @@ has_subclass(Oid relationId)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relationId);
 
-	result = ((Form_pg_class) GETSTRUCT(tuple))->relhassubclass;
+	result = (GETSTRUCT(pg_class, tuple))->relhassubclass;
 	ReleaseSysCache(tuple);
 	return result;
 }
@@ -473,7 +473,7 @@ typeInheritsFrom(Oid subclassTypeId, Oid superclassTypeId)
 
 		while ((inhtup = systable_getnext(inhscan)) != NULL)
 		{
-			Form_pg_inherits inh = (Form_pg_inherits) GETSTRUCT(inhtup);
+			Form_pg_inherits inh = GETSTRUCT(pg_inherits, inhtup);
 			Oid			inhparent = inh->inhparent;
 
 			/* If this is the target superclass, we're done */
@@ -575,13 +575,13 @@ DeleteInheritsTuple(Oid inhrelid, Oid inhparent, bool expect_detach_pending,
 		Oid			parent;
 
 		/* Compare inhparent if it was given, and do the actual deletion. */
-		parent = ((Form_pg_inherits) GETSTRUCT(inheritsTuple))->inhparent;
+		parent = (GETSTRUCT(pg_inherits, inheritsTuple))->inhparent;
 		if (!OidIsValid(inhparent) || parent == inhparent)
 		{
 			bool		detach_pending;
 
 			detach_pending =
-				((Form_pg_inherits) GETSTRUCT(inheritsTuple))->inhdetachpending;
+				(GETSTRUCT(pg_inherits, inheritsTuple))->inhdetachpending;
 
 			/*
 			 * Raise error depending on state.  This should only happen for
@@ -643,7 +643,7 @@ PartitionHasPendingDetach(Oid partoid)
 		bool		detached;
 
 		detached =
-			((Form_pg_inherits) GETSTRUCT(inheritsTuple))->inhdetachpending;
+			(GETSTRUCT(pg_inherits, inheritsTuple))->inhdetachpending;
 
 		/* Done */
 		systable_endscan(scan);
diff --git a/src/backend/catalog/pg_operator.c b/src/backend/catalog/pg_operator.c
index 630bf3e56c..6b4db2306f 100644
--- a/src/backend/catalog/pg_operator.c
+++ b/src/backend/catalog/pg_operator.c
@@ -143,7 +143,7 @@ OperatorGet(const char *operatorName,
 						  ObjectIdGetDatum(operatorNamespace));
 	if (HeapTupleIsValid(tup))
 	{
-		Form_pg_operator oprform = (Form_pg_operator) GETSTRUCT(tup);
+		Form_pg_operator oprform = GETSTRUCT(pg_operator, tup);
 
 		operatorObjectId = oprform->oid;
 		*defined = RegProcedureIsValid(oprform->oprcode);
@@ -677,7 +677,7 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 	/* Update the commutator's tuple if need be. */
 	if (HeapTupleIsValid(tup))
 	{
-		Form_pg_operator t = (Form_pg_operator) GETSTRUCT(tup);
+		Form_pg_operator t = GETSTRUCT(pg_operator, tup);
 		bool		update_commutator = false;
 
 		/*
@@ -722,7 +722,7 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 
 	if (HeapTupleIsValid(tup))
 	{
-		Form_pg_operator t = (Form_pg_operator) GETSTRUCT(tup);
+		Form_pg_operator t = GETSTRUCT(pg_operator, tup);
 		bool		update_negator = false;
 
 		/*
@@ -778,7 +778,7 @@ makeOperatorDependencies(HeapTuple tuple,
 						 bool makeExtensionDep,
 						 bool isUpdate)
 {
-	Form_pg_operator oper = (Form_pg_operator) GETSTRUCT(tuple);
+	Form_pg_operator oper = GETSTRUCT(pg_operator, tuple);
 	ObjectAddress myself,
 				referenced;
 	ObjectAddresses *addrs;
diff --git a/src/backend/catalog/pg_proc.c b/src/backend/catalog/pg_proc.c
index a9fe45e347..8eed22b3fb 100644
--- a/src/backend/catalog/pg_proc.c
+++ b/src/backend/catalog/pg_proc.c
@@ -365,7 +365,7 @@ ProcedureCreate(const char *procedureName,
 	if (HeapTupleIsValid(oldtup))
 	{
 		/* There is one; okay to replace it? */
-		Form_pg_proc oldproc = (Form_pg_proc) GETSTRUCT(oldtup);
+		Form_pg_proc oldproc = GETSTRUCT(pg_proc, oldtup);
 		Datum		proargnames;
 		bool		isnull;
 		const char *dropcmd;
@@ -586,7 +586,7 @@ ProcedureCreate(const char *procedureName,
 	}
 
 
-	retval = ((Form_pg_proc) GETSTRUCT(tup))->oid;
+	retval = (GETSTRUCT(pg_proc, tup))->oid;
 
 	/*
 	 * Create dependencies for the new function.  If we are updating an
@@ -842,7 +842,7 @@ fmgr_sql_validator(PG_FUNCTION_ARGS)
 	tuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcoid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for function %u", funcoid);
-	proc = (Form_pg_proc) GETSTRUCT(tuple);
+	proc = GETSTRUCT(pg_proc, tuple);
 
 	/* Disallow pseudotype result */
 	/* except for RECORD, VOID, or polymorphic */
diff --git a/src/backend/catalog/pg_publication.c b/src/backend/catalog/pg_publication.c
index c365de3a72..2819aafe75 100644
--- a/src/backend/catalog/pg_publication.c
+++ b/src/backend/catalog/pg_publication.c
@@ -236,7 +236,7 @@ pg_relation_is_publishable(PG_FUNCTION_ARGS)
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		PG_RETURN_NULL();
-	result = is_publishable_class(relid, (Form_pg_class) GETSTRUCT(tuple));
+	result = is_publishable_class(relid, GETSTRUCT(pg_class, tuple));
 	ReleaseSysCache(tuple);
 	PG_RETURN_BOOL(result);
 }
@@ -678,7 +678,7 @@ GetRelationPublications(Oid relid)
 	for (i = 0; i < pubrellist->n_members; i++)
 	{
 		HeapTuple	tup = &pubrellist->members[i]->tuple;
-		Oid			pubid = ((Form_pg_publication_rel) GETSTRUCT(tup))->prpubid;
+		Oid			pubid = (GETSTRUCT(pg_publication_rel, tup))->prpubid;
 
 		result = lappend_oid(result, pubid);
 	}
@@ -719,7 +719,7 @@ GetPublicationRelations(Oid pubid, PublicationPartOpt pub_partopt)
 	{
 		Form_pg_publication_rel pubrel;
 
-		pubrel = (Form_pg_publication_rel) GETSTRUCT(tup);
+		pubrel = GETSTRUCT(pg_publication_rel, tup);
 		result = GetPubPartitionOptionRelations(result, pub_partopt,
 												pubrel->prrelid);
 	}
@@ -760,7 +760,7 @@ GetAllTablesPublications(void)
 	result = NIL;
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Oid			oid = ((Form_pg_publication) GETSTRUCT(tup))->oid;
+		Oid			oid = (GETSTRUCT(pg_publication, tup))->oid;
 
 		result = lappend_oid(result, oid);
 	}
@@ -798,7 +798,7 @@ GetAllTablesPublicationRelations(bool pubviaroot)
 
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_class relForm = (Form_pg_class) GETSTRUCT(tuple);
+		Form_pg_class relForm = GETSTRUCT(pg_class, tuple);
 		Oid			relid = relForm->oid;
 
 		if (is_publishable_class(relid, relForm) &&
@@ -819,7 +819,7 @@ GetAllTablesPublicationRelations(bool pubviaroot)
 
 		while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 		{
-			Form_pg_class relForm = (Form_pg_class) GETSTRUCT(tuple);
+			Form_pg_class relForm = GETSTRUCT(pg_class, tuple);
 			Oid			relid = relForm->oid;
 
 			if (is_publishable_class(relid, relForm) &&
@@ -863,7 +863,7 @@ GetPublicationSchemas(Oid pubid)
 	{
 		Form_pg_publication_namespace pubsch;
 
-		pubsch = (Form_pg_publication_namespace) GETSTRUCT(tup);
+		pubsch = GETSTRUCT(pg_publication_namespace, tup);
 
 		result = lappend_oid(result, pubsch->pnnspid);
 	}
@@ -890,7 +890,7 @@ GetSchemaPublications(Oid schemaid)
 	for (i = 0; i < pubschlist->n_members; i++)
 	{
 		HeapTuple	tup = &pubschlist->members[i]->tuple;
-		Oid			pubid = ((Form_pg_publication_namespace) GETSTRUCT(tup))->pnpubid;
+		Oid			pubid = (GETSTRUCT(pg_publication_namespace, tup))->pnpubid;
 
 		result = lappend_oid(result, pubid);
 	}
@@ -925,7 +925,7 @@ GetSchemaPublicationRelations(Oid schemaid, PublicationPartOpt pub_partopt)
 	scan = table_beginscan_catalog(classRel, 1, key);
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_class relForm = (Form_pg_class) GETSTRUCT(tuple);
+		Form_pg_class relForm = GETSTRUCT(pg_class, tuple);
 		Oid			relid = relForm->oid;
 		char		relkind;
 
@@ -995,7 +995,7 @@ GetPublication(Oid pubid)
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for publication %u", pubid);
 
-	pubform = (Form_pg_publication) GETSTRUCT(tup);
+	pubform = GETSTRUCT(pg_publication, tup);
 
 	pub = (Publication *) palloc(sizeof(Publication));
 	pub->oid = pubid;
@@ -1068,7 +1068,7 @@ get_publication_name(Oid pubid, bool missing_ok)
 		return NULL;
 	}
 
-	pubform = (Form_pg_publication) GETSTRUCT(tup);
+	pubform = GETSTRUCT(pg_publication, tup);
 	pubname = pstrdup(NameStr(pubform->pubname));
 
 	ReleaseSysCache(tup);
diff --git a/src/backend/catalog/pg_shdepend.c b/src/backend/catalog/pg_shdepend.c
index 3e8fa008b9..b0f6ca6f8a 100644
--- a/src/backend/catalog/pg_shdepend.c
+++ b/src/backend/catalog/pg_shdepend.c
@@ -242,7 +242,7 @@ shdepChangeDep(Relation sdepRel,
 	while ((scantup = systable_getnext(scan)) != NULL)
 	{
 		/* Ignore if not of the target dependency type */
-		if (((Form_pg_shdepend) GETSTRUCT(scantup))->deptype != deptype)
+		if ((GETSTRUCT(pg_shdepend, scantup))->deptype != deptype)
 			continue;
 		/* Caller screwed up if multiple matches */
 		if (oldtup)
@@ -263,7 +263,7 @@ shdepChangeDep(Relation sdepRel,
 	else if (oldtup)
 	{
 		/* Need to update existing entry */
-		Form_pg_shdepend shForm = (Form_pg_shdepend) GETSTRUCT(oldtup);
+		Form_pg_shdepend shForm = GETSTRUCT(pg_shdepend, oldtup);
 
 		/* Since oldtup is a copy, we can just modify it in-memory */
 		shForm->refclassid = refclassid;
@@ -692,7 +692,7 @@ checkSharedDependencies(Oid classId, Oid objectId,
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_shdepend sdepForm = (Form_pg_shdepend) GETSTRUCT(tup);
+		Form_pg_shdepend sdepForm = GETSTRUCT(pg_shdepend, tup);
 
 		object.classId = sdepForm->classid;
 		object.objectId = sdepForm->objid;
@@ -907,7 +907,7 @@ copyTemplateDependencies(Oid templateDbId, Oid newDbId)
 		memset(slot[slot_stored_count]->tts_isnull, false,
 			   slot[slot_stored_count]->tts_tupleDescriptor->natts * sizeof(bool));
 
-		shdep = (Form_pg_shdepend) GETSTRUCT(tup);
+		shdep = GETSTRUCT(pg_shdepend, tup);
 
 		slot[slot_stored_count]->tts_values[Anum_pg_shdepend_dbid - 1] = ObjectIdGetDatum(newDbId);
 		slot[slot_stored_count]->tts_values[Anum_pg_shdepend_classid - 1] = shdep->classid;
@@ -1115,7 +1115,7 @@ shdepDropDependency(Relation sdepRel,
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_shdepend shdepForm = (Form_pg_shdepend) GETSTRUCT(tup);
+		Form_pg_shdepend shdepForm = GETSTRUCT(pg_shdepend, tup);
 
 		/* Filter entries according to additional parameters */
 		if (OidIsValid(refclassId) && shdepForm->refclassid != refclassId)
@@ -1347,7 +1347,7 @@ shdepDropOwned(List *roleids, DropBehavior behavior)
 
 		while ((tuple = systable_getnext(scan)) != NULL)
 		{
-			Form_pg_shdepend sdepForm = (Form_pg_shdepend) GETSTRUCT(tuple);
+			Form_pg_shdepend sdepForm = GETSTRUCT(pg_shdepend, tuple);
 			ObjectAddress obj;
 
 			/*
@@ -1497,7 +1497,7 @@ shdepReassignOwned(List *roleids, Oid newrole)
 
 		while ((tuple = systable_getnext(scan)) != NULL)
 		{
-			Form_pg_shdepend sdepForm = (Form_pg_shdepend) GETSTRUCT(tuple);
+			Form_pg_shdepend sdepForm = GETSTRUCT(pg_shdepend, tuple);
 			MemoryContext cxt,
 						oldcxt;
 
diff --git a/src/backend/catalog/pg_subscription.c b/src/backend/catalog/pg_subscription.c
index 8856ce3b50..cb6e1675d9 100644
--- a/src/backend/catalog/pg_subscription.c
+++ b/src/backend/catalog/pg_subscription.c
@@ -58,7 +58,7 @@ GetSubscription(Oid subid, bool missing_ok)
 		elog(ERROR, "cache lookup failed for subscription %u", subid);
 	}
 
-	subform = (Form_pg_subscription) GETSTRUCT(tup);
+	subform = GETSTRUCT(pg_subscription, tup);
 
 	sub = (Subscription *) palloc(sizeof(Subscription));
 	sub->oid = subid;
@@ -239,7 +239,7 @@ get_subscription_name(Oid subid, bool missing_ok)
 		return NULL;
 	}
 
-	subform = (Form_pg_subscription) GETSTRUCT(tup);
+	subform = GETSTRUCT(pg_subscription, tup);
 	subname = pstrdup(NameStr(subform->subname));
 
 	ReleaseSysCache(tup);
@@ -399,7 +399,7 @@ GetSubscriptionRelState(Oid subid, Oid relid, XLogRecPtr *sublsn)
 	}
 
 	/* Get the state. */
-	substate = ((Form_pg_subscription_rel) GETSTRUCT(tup))->srsubstate;
+	substate = (GETSTRUCT(pg_subscription_rel, tup))->srsubstate;
 
 	/* Get the LSN */
 	d = SysCacheGetAttr(SUBSCRIPTIONRELMAP, tup,
@@ -456,7 +456,7 @@ RemoveSubscriptionRel(Oid subid, Oid relid)
 	{
 		Form_pg_subscription_rel subrel;
 
-		subrel = (Form_pg_subscription_rel) GETSTRUCT(tup);
+		subrel = GETSTRUCT(pg_subscription_rel, tup);
 
 		/*
 		 * We don't allow to drop the relation mapping when the table
@@ -555,7 +555,7 @@ GetSubscriptionRelations(Oid subid)
 		Datum		d;
 		bool		isnull;
 
-		subrel = (Form_pg_subscription_rel) GETSTRUCT(tup);
+		subrel = GETSTRUCT(pg_subscription_rel, tup);
 
 		relstate = (SubscriptionRelState *) palloc(sizeof(SubscriptionRelState));
 		relstate->relid = subrel->srrelid;
@@ -614,7 +614,7 @@ GetSubscriptionNotReadyRelations(Oid subid)
 		Datum		d;
 		bool		isnull;
 
-		subrel = (Form_pg_subscription_rel) GETSTRUCT(tup);
+		subrel = GETSTRUCT(pg_subscription_rel, tup);
 
 		relstate = (SubscriptionRelState *) palloc(sizeof(SubscriptionRelState));
 		relstate->relid = subrel->srrelid;
diff --git a/src/backend/catalog/pg_type.c b/src/backend/catalog/pg_type.c
index 03788cb975..9fb756d728 100644
--- a/src/backend/catalog/pg_type.c
+++ b/src/backend/catalog/pg_type.c
@@ -424,7 +424,7 @@ TypeCreate(Oid newTypeOid,
 							  ObjectIdGetDatum(typeNamespace));
 	if (HeapTupleIsValid(tup))
 	{
-		Form_pg_type typform = (Form_pg_type) GETSTRUCT(tup);
+		Form_pg_type typform = GETSTRUCT(pg_type, tup);
 
 		/*
 		 * check that the type is not already defined.  It may exist as a
@@ -562,7 +562,7 @@ GenerateTypeDependencies(HeapTuple typeTuple,
 						 bool makeExtensionDep,
 						 bool rebuild)
 {
-	Form_pg_type typeForm = (Form_pg_type) GETSTRUCT(typeTuple);
+	Form_pg_type typeForm = GETSTRUCT(pg_type, typeTuple);
 	Oid			typeObjectId = typeForm->oid;
 	Datum		datum;
 	bool		isNull;
@@ -751,7 +751,7 @@ RenameTypeInternal(Oid typeOid, const char *newTypeName, Oid typeNamespace)
 	tuple = SearchSysCacheCopy1(TYPEOID, ObjectIdGetDatum(typeOid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for type %u", typeOid);
-	typ = (Form_pg_type) GETSTRUCT(tuple);
+	typ = GETSTRUCT(pg_type, tuple);
 
 	/* We are not supposed to be changing schemas here */
 	Assert(typeNamespace == typ->typnamespace);
diff --git a/src/backend/catalog/toasting.c b/src/backend/catalog/toasting.c
index 9bc10729b0..5b10baff8a 100644
--- a/src/backend/catalog/toasting.c
+++ b/src/backend/catalog/toasting.c
@@ -341,7 +341,7 @@ create_toast_table(Relation rel, Oid toastOid, Oid toastIndexOid,
 	if (!HeapTupleIsValid(reltup))
 		elog(ERROR, "cache lookup failed for relation %u", relOid);
 
-	((Form_pg_class) GETSTRUCT(reltup))->reltoastrelid = toast_relid;
+	(GETSTRUCT(pg_class, reltup))->reltoastrelid = toast_relid;
 
 	if (!IsBootstrapProcessingMode())
 	{
diff --git a/src/backend/commands/alter.c b/src/backend/commands/alter.c
index 5456b8222b..018582b304 100644
--- a/src/backend/commands/alter.c
+++ b/src/backend/commands/alter.c
@@ -243,27 +243,27 @@ AlterObjectRename_internal(Relation rel, Oid objectId, const char *new_name)
 	 */
 	if (classId == ProcedureRelationId)
 	{
-		Form_pg_proc proc = (Form_pg_proc) GETSTRUCT(oldtup);
+		Form_pg_proc proc = GETSTRUCT(pg_proc, oldtup);
 
 		IsThereFunctionInNamespace(new_name, proc->pronargs,
 								   &proc->proargtypes, proc->pronamespace);
 	}
 	else if (classId == CollationRelationId)
 	{
-		Form_pg_collation coll = (Form_pg_collation) GETSTRUCT(oldtup);
+		Form_pg_collation coll = GETSTRUCT(pg_collation, oldtup);
 
 		IsThereCollationInNamespace(new_name, coll->collnamespace);
 	}
 	else if (classId == OperatorClassRelationId)
 	{
-		Form_pg_opclass opc = (Form_pg_opclass) GETSTRUCT(oldtup);
+		Form_pg_opclass opc = GETSTRUCT(pg_opclass, oldtup);
 
 		IsThereOpClassInNamespace(new_name, opc->opcmethod,
 								  opc->opcnamespace);
 	}
 	else if (classId == OperatorFamilyRelationId)
 	{
-		Form_pg_opfamily opf = (Form_pg_opfamily) GETSTRUCT(oldtup);
+		Form_pg_opfamily opf = GETSTRUCT(pg_opfamily, oldtup);
 
 		IsThereOpFamilyInNamespace(new_name, opf->opfmethod,
 								   opf->opfnamespace);
@@ -769,27 +769,27 @@ AlterObjectNamespace_internal(Relation rel, Oid objid, Oid nspOid)
 	 */
 	if (classId == ProcedureRelationId)
 	{
-		Form_pg_proc proc = (Form_pg_proc) GETSTRUCT(tup);
+		Form_pg_proc proc = GETSTRUCT(pg_proc, tup);
 
 		IsThereFunctionInNamespace(NameStr(proc->proname), proc->pronargs,
 								   &proc->proargtypes, nspOid);
 	}
 	else if (classId == CollationRelationId)
 	{
-		Form_pg_collation coll = (Form_pg_collation) GETSTRUCT(tup);
+		Form_pg_collation coll = GETSTRUCT(pg_collation, tup);
 
 		IsThereCollationInNamespace(NameStr(coll->collname), nspOid);
 	}
 	else if (classId == OperatorClassRelationId)
 	{
-		Form_pg_opclass opc = (Form_pg_opclass) GETSTRUCT(tup);
+		Form_pg_opclass opc = GETSTRUCT(pg_opclass, tup);
 
 		IsThereOpClassInNamespace(NameStr(opc->opcname),
 								  opc->opcmethod, nspOid);
 	}
 	else if (classId == OperatorFamilyRelationId)
 	{
-		Form_pg_opfamily opf = (Form_pg_opfamily) GETSTRUCT(tup);
+		Form_pg_opfamily opf = GETSTRUCT(pg_opfamily, tup);
 
 		IsThereOpFamilyInNamespace(NameStr(opf->opfname),
 								   opf->opfmethod, nspOid);
diff --git a/src/backend/commands/amcmds.c b/src/backend/commands/amcmds.c
index 914cfa4cc7..ea057efe80 100644
--- a/src/backend/commands/amcmds.c
+++ b/src/backend/commands/amcmds.c
@@ -134,7 +134,7 @@ get_am_type_oid(const char *amname, char amtype, bool missing_ok)
 	tup = SearchSysCache1(AMNAME, CStringGetDatum(amname));
 	if (HeapTupleIsValid(tup))
 	{
-		Form_pg_am	amform = (Form_pg_am) GETSTRUCT(tup);
+		Form_pg_am	amform = GETSTRUCT(pg_am, tup);
 
 		if (amtype != '\0' &&
 			amform->amtype != amtype)
@@ -197,7 +197,7 @@ get_am_name(Oid amOid)
 	tup = SearchSysCache1(AMOID, ObjectIdGetDatum(amOid));
 	if (HeapTupleIsValid(tup))
 	{
-		Form_pg_am	amform = (Form_pg_am) GETSTRUCT(tup);
+		Form_pg_am	amform = GETSTRUCT(pg_am, tup);
 
 		result = pstrdup(NameStr(amform->amname));
 		ReleaseSysCache(tup);
diff --git a/src/backend/commands/analyze.c b/src/backend/commands/analyze.c
index 07613c38b5..156384f59e 100644
--- a/src/backend/commands/analyze.c
+++ b/src/backend/commands/analyze.c
@@ -1057,7 +1057,7 @@ examine_attribute(Relation onerel, int attnum, Node *index_expr)
 								   ObjectIdGetDatum(stats->attrtypid));
 	if (!HeapTupleIsValid(typtuple))
 		elog(ERROR, "cache lookup failed for type %u", stats->attrtypid);
-	stats->attrtype = (Form_pg_type) GETSTRUCT(typtuple);
+	stats->attrtype = GETSTRUCT(pg_type, typtuple);
 	stats->anl_context = anl_context;
 	stats->tupattnum = attnum;
 
diff --git a/src/backend/commands/cluster.c b/src/backend/commands/cluster.c
index dc35b02910..d5163e038e 100644
--- a/src/backend/commands/cluster.c
+++ b/src/backend/commands/cluster.c
@@ -590,7 +590,7 @@ mark_index_clustered(Relation rel, Oid indexOid, bool is_internal)
 										 ObjectIdGetDatum(thisIndexOid));
 		if (!HeapTupleIsValid(indexTuple))
 			elog(ERROR, "cache lookup failed for index %u", thisIndexOid);
-		indexForm = (Form_pg_index) GETSTRUCT(indexTuple);
+		indexForm = GETSTRUCT(pg_index, indexTuple);
 
 		/*
 		 * Unset the bit if set.  We know it's wrong because we checked this
@@ -1003,7 +1003,7 @@ copy_table_data(Oid OIDNewHeap, Oid OIDOldHeap, Oid OIDOldIndex, bool verbose,
 	reltup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(OIDNewHeap));
 	if (!HeapTupleIsValid(reltup))
 		elog(ERROR, "cache lookup failed for relation %u", OIDNewHeap);
-	relform = (Form_pg_class) GETSTRUCT(reltup);
+	relform = GETSTRUCT(pg_class, reltup);
 
 	relform->relpages = num_pages;
 	relform->reltuples = num_tuples;
@@ -1072,12 +1072,12 @@ swap_relation_files(Oid r1, Oid r2, bool target_is_pg_class,
 	reltup1 = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(r1));
 	if (!HeapTupleIsValid(reltup1))
 		elog(ERROR, "cache lookup failed for relation %u", r1);
-	relform1 = (Form_pg_class) GETSTRUCT(reltup1);
+	relform1 = GETSTRUCT(pg_class, reltup1);
 
 	reltup2 = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(r2));
 	if (!HeapTupleIsValid(reltup2))
 		elog(ERROR, "cache lookup failed for relation %u", r2);
-	relform2 = (Form_pg_class) GETSTRUCT(reltup2);
+	relform2 = GETSTRUCT(pg_class, reltup2);
 
 	relfilenumber1 = relform1->relfilenode;
 	relfilenumber2 = relform2->relfilenode;
@@ -1515,7 +1515,7 @@ finish_heap_swap(Oid OIDOldHeap, Oid OIDNewHeap,
 		reltup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(OIDOldHeap));
 		if (!HeapTupleIsValid(reltup))
 			elog(ERROR, "cache lookup failed for relation %u", OIDOldHeap);
-		relform = (Form_pg_class) GETSTRUCT(reltup);
+		relform = GETSTRUCT(pg_class, reltup);
 
 		relform->relfrozenxid = frozenXid;
 		relform->relminmxid = cutoffMulti;
@@ -1638,7 +1638,7 @@ get_tables_to_cluster(MemoryContext cluster_context)
 	{
 		RelToCluster *rtc;
 
-		index = (Form_pg_index) GETSTRUCT(indexTuple);
+		index = GETSTRUCT(pg_index, indexTuple);
 
 		if (!pg_class_ownercheck(index->indrelid, GetUserId()))
 			continue;
diff --git a/src/backend/commands/collationcmds.c b/src/backend/commands/collationcmds.c
index fcfc02d2ae..956249259f 100644
--- a/src/backend/commands/collationcmds.c
+++ b/src/backend/commands/collationcmds.c
@@ -137,9 +137,9 @@ DefineCollation(ParseState *pstate, List *names, List *parameters, bool if_not_e
 		if (!HeapTupleIsValid(tp))
 			elog(ERROR, "cache lookup failed for collation %u", collid);
 
-		collprovider = ((Form_pg_collation) GETSTRUCT(tp))->collprovider;
-		collisdeterministic = ((Form_pg_collation) GETSTRUCT(tp))->collisdeterministic;
-		collencoding = ((Form_pg_collation) GETSTRUCT(tp))->collencoding;
+		collprovider = (GETSTRUCT(pg_collation, tp))->collprovider;
+		collisdeterministic = (GETSTRUCT(pg_collation, tp))->collisdeterministic;
+		collencoding = (GETSTRUCT(pg_collation, tp))->collencoding;
 
 		datum = SysCacheGetAttr(COLLOID, tp, Anum_pg_collation_collcollate, &isnull);
 		if (!isnull)
@@ -373,7 +373,7 @@ AlterCollation(AlterCollationStmt *stmt)
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for collation %u", collOid);
 
-	collForm = (Form_pg_collation) GETSTRUCT(tup);
+	collForm = GETSTRUCT(pg_collation, tup);
 	datum = SysCacheGetAttr(COLLOID, tup, Anum_pg_collation_collversion, &isnull);
 	oldversion = isnull ? NULL : TextDatumGetCString(datum);
 
@@ -438,7 +438,7 @@ pg_collation_actual_version(PG_FUNCTION_ARGS)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("collation with OID %u does not exist", collid)));
 
-	collprovider = ((Form_pg_collation) GETSTRUCT(tp))->collprovider;
+	collprovider = (GETSTRUCT(pg_collation, tp))->collprovider;
 
 	if (collprovider != COLLPROVIDER_DEFAULT)
 	{
